LibreOffice: AccessibleChartElement Service Reference

LibreOffice LibreOffice 6.4 SDK API Reference

Exported Interfaces | List of all members
AccessibleChartElement Service Reference

This service is supported by all components that are contained in the view of a chart document that are controlled by the chart. More...

`import"AccessibleChartElement.idl";`

Inheritance diagram for AccessibleChartElement:

## Exported Interfaces
interface | ::com::sun::star::accessibility::XAccessible
| Base interface for being accessible. More...
interface | ::com::sun::star::accessibility::XAccessibleContext
| Give access to the structural information of a chart element. More...
interface | ::com::sun::star::accessibility::XAccessibleComponent
| Give access to the graphical representation of a chart element. More...
interface | ::com::sun::star::accessibility::XAccessibleExtendedComponent
| Give extended access to the graphical representation of a chart element. More...

## Additional Inherited Members
Public Member Functions inherited from XAccessible
XAccessibleContext | getAccessibleContext ()
| Returns the AccessibleContext associated with this object. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...
Public Member Functions inherited from XAccessibleContext
long | getAccessibleChildCount ()
| Return the number of children. More...
XAccessible | getAccessibleChild ([in] long i) raises (::com::sun::star::lang::IndexOutOfBoundsException)
| Returns the i-th child of this object. More...
XAccessible | getAccessibleParent ()
| Returns the parent of this object. More...
long | getAccessibleIndexInParent ()
| Returns the index of this object in its accessible parent. More...
short | getAccessibleRole ()
| Returns the role of this object. More...
string | getAccessibleDescription ()
| Returns the object's description. More...
string | getAccessibleName ()
| Return the object's localized name. More...
XAccessibleRelationSet | getAccessibleRelationSet ()
| Returns the set of relations defined for this object. More...
XAccessibleStateSet | getAccessibleStateSet ()
| Returns the set of states that are currently active for this object. More...
::com::sun::star::lang::Locale | getLocale () raises (IllegalAccessibleComponentStateException)
| Returns the locale of the component. More...
Public Member Functions inherited from XAccessibleComponent
boolean | containsPoint ([in] ::com::sun::star::awt::Point Point)
| Tests whether the specified point lies within this object's bounds. More...
XAccessible | getAccessibleAtPoint ([in] ::com::sun::star::awt::Point Point)
| Returns the Accessible child that is rendered under the given point. More...
::com::sun::star::awt::Rectangle | getBounds ()
| Returns the bounding box of this object. More...
::com::sun::star::awt::Point | getLocation ()
| Returns the location of the upper left corner of the object's bounding box relative to the parent. More...
::com::sun::star::awt::Point | getLocationOnScreen ()
| Returns the location of the upper left corner of the object's bounding box in screen coordinates. More...
::com::sun::star::awt::Size | getSize ()
| Returns the size of this object's bounding box. More...
void | grabFocus ()
| Grabs the focus to this object. More...
::com::sun::star::util::Color | getForeground ()
| Returns the foreground color of this object. More...
::com::sun::star::util::Color | getBackground ()
| Returns the background color of this object. More...
Protected Member Functions inherited from XAccessibleExtendedComponent
::com::sun::star::awt::XFont | getFont ()
| Returns the font of this object. More...
string | getTitledBorderText ()
| Returns the titled border text. More...
string | getToolTipText ()
| Returns the tool tip text of this object. More...

## Detailed Description

This service is supported by all components that are contained in the view of a chart document that are controlled by the chart.

Shapes added by a user via the clipboard are not treated as chart elements.

The list of objects that implement this service is com::sun::star::chart::ChartTitle, com::sun::star::chart::ChartLegend, com::sun::star::chart::Diagram, com::sun::star::chart::ChartAxis, com::sun::star::chart::ChartDataRowProperties, com::sun::star::chart::ChartDataPointProperties.

The com::sun::star::accessibility::XAccessibleExtendedComponent is supported by all chart elements.

Since
  OOo 1.1.2

## Exported Interfaces

## ◆ ::com::sun::star::accessibility::XAccessible

interface ::com::sun::star::accessibility::XAccessible

Base interface for being accessible.

It gives access to the com::sun::star::accessibility::XAccessibleContext interface.

## ◆ ::com::sun::star::accessibility::XAccessibleComponent

interface ::com::sun::star::accessibility::XAccessibleComponent

Give access to the graphical representation of a chart element.

The coordinate oriented methods `contains`, `getAccessibleAt`, `getBounds`, `getLocation`, `getLocationOnScreen`, and `getSize` work on pixel coordinates. (To transform between the internal 100th of mm and pixels a chart element has to have access to information that allows it to do so. This information is the enclosing window's size in pixel, 100th of mm, and its own relative position in one or the other coordinate system).

Focus handling depends on support of the com::sun::star::accessibility::XAccessibleText and com::sun::star::accessibility::XAccessibleEditableText interfaces.

Key bindings are not supported at the moment

## ◆ ::com::sun::star::accessibility::XAccessibleContext

interface ::com::sun::star::accessibility::XAccessibleContext

Give access to the structural information of a chart element.

You can access the following information for the shapes of the above listed types:

Role
  All chart elements have the role com::sun::star::accessibility::AccessibleRole::SHAPE.
Name
  For unique elements you get fixed names. The unique elements are the titles, legend, diagram and axes. The names you get for them are "main-title", "sub-title", "(x|y|z)-axis-title", "legend", "diagram", "(x|y|z)-axis" and "second-(x|y)-axis", respectively.
Description
  Descriptions contain a list of selected attributes. These attributes are, if applicable: foreground and background color, line width, font name and size. The purpose of these attributes is to give a rough description of the more simple geometric shapes. The list is very restricted in order to avoid overwhelming or confusing the user.
Children
  The com::sun::star::chart::Diagram and the com::sun::star::chart::ChartLegend contain children, all other objects in a chart do not, i.e., are leaves in the document representation tree.
Parent
  Because the `setParent` method from the JAVA has been removed, the reference to the parent has to be provided in an implementation specific way.
Relations

  They are not used at the moment.

States
  The states supported by this service are:
  - com::sun::star::accessibility::AccessibleStateType::DEFUNC is set if an object was removed. This indicates that the user should release all references to the accessible object. If this state is set then no other of the states below is set.
  - com::sun::star::accessibility::AccessibleStateType::EDITABLE
  - com::sun::star::accessibility::AccessibleStateType::ENABLED is always set.*
  - com::sun::star::accessibility::AccessibleStateType::MULTI_LINE is set for all titles.
  - com::sun::star::accessibility::AccessibleStateType::OPAQUE is set for all elements that do have a transparency attributes set to 0% and no transparency gradient.
  - com::sun::star::accessibility::AccessibleStateType::RESIZABLE Is set for the diagram object only. All other chart elements may not be resized.
  - com::sun::star::accessibility::AccessibleStateType::SELECTABLE
  - com::sun::star::accessibility::AccessibleStateType::SELECTED
  - com::sun::star::accessibility::AccessibleStateType::SHOWING is always set.*
  - com::sun::star::accessibility::AccessibleStateType::VISIBLE is always set.*
  *always, except if the state com::sun::star::accessibility::AccessibleStateType::DEFUNC is set.
Locale
  is supported.
Property change listeners
  Property change listeners that are registered with a chart element are informed if the size or position or an attribute changed. The last point needs a short explanation: An attribute change is signaled even if that attribute is not part of the shape's description and is therefore not explicitly represented by the UAA.

## ◆ ::com::sun::star::accessibility::XAccessibleExtendedComponent

interface ::com::sun::star::accessibility::XAccessibleExtendedComponent
| optional

Give extended access to the graphical representation of a chart element.

This interface is used primarily to provide the predominant foreground and background colors and—if applicable, i.e. the com::sun::star::accessibility::XAccessibleText interface is supported—information about the font used to display text.

The foreground and background colors may in some cases be directly taken from the object. In other cases, for example when a gradient or a texture is used, they have to be interpolated. The color returned may not be appropriate in all cases.

Specifying the font used for displaying text depends on the transformation of UNO API font information into the Java™ format. However, if the UAA is used directly, this is of course not an issue.

The support of this interface is optional to reduce overhead in case that no text is displayed and color information can not be determined with an acceptable cost.

The documentation for this service was generated from the following file:

- com/sun/star/chart/AccessibleChartElement.idl